﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private cvs As Canvas
	Private mLbl As Label
	Private su As StringUtils
	

End Sub

Public Sub Initialize (Target As Object, EventName As String)

End Sub

Public Sub DesignerCreateView(Base As Panel, lbl As Label, props As Map)
	Dim bmp As Bitmap
	bmp.InitializeMutable(1,1) 'ignore
	cvs.Initialize2(bmp)
	Dim parent As Panel = Base.Parent
	
	parent.AddView(lbl, Base.Left, Base.Top, Base.Width, Base.Height)
	Base.RemoveView
	mLbl = lbl
	mLbl.Padding = Array As Int(0, 0, 0, 0)
	Dim jo As JavaObject = mLbl
	jo.RunMethod("setIncludeFontPadding", Array(False))
	setText(mLbl.Text)
End Sub


Public Sub setText(value As Object)
	mLbl.Text = value
	Log("mlb1 text = " & mLbl.text & ", " & value)
	Dim multipleLines As Boolean = mLbl.Text.Contains(CRLF)
	Dim size As Float
	For size = 4 To 300
		If CheckSize(size, multipleLines) Then Exit
	Next
	size = size - 1
	If CheckSize(size, multipleLines) Then size = size - 0.5
	mLbl.TextSize = size
	'mLbl.Invalidate
End Sub

'returns true if the size is too large
Private Sub CheckSize(size As Float, MultipleLines As Boolean) As Boolean
	mLbl.TextSize = size
	If MultipleLines Then
		Return su.MeasureMultilineTextHeight(mLbl, mLbl.Text) > mLbl.Height
	Else
		Return cvs.MeasureStringWidth(mLbl.Text, mLbl.Typeface, size) > mLbl.Width Or _
			su.MeasureMultilineTextHeight(mLbl, mLbl.Text) > mLbl.Height
	End If
End Sub



Public Sub getHeight As Int
	Return mLbl.Height
End Sub

Public Sub setHeight(ll As Int)
	mLbl.Height = ll
End Sub

Public Sub getVisible As Boolean
	Return mLbl.Visible
End Sub

Public Sub setVisible(Visible As Boolean)
	mLbl.Visible = Visible
End Sub

Public Sub getLeft As Int
	Return mLbl.left
End Sub

Public Sub setLeft(ll As Int)
	mLbl.left = ll
End Sub

public Sub getTextSize As Float
	Return mLbl.TextSize
End Sub


Public Sub getTextWidth As Float
	Return cvs.MeasureStringWidth(mLbl.Text, mLbl.Typeface, mLbl.TextSize)
	
End Sub

Public Sub getTextHeight As Float
	Return cvs.MeasureStringHeight(mLbl.Text, mLbl.Typeface, mLbl.TextSize)
End Sub


Public Sub getText As Object
	Return mLbl.Text
End Sub


Public Sub getWidth As Int
	Return mLbl.Width
End Sub

Public Sub setWidth(ll As Int)
	mLbl.Width = ll
End Sub

'Public Sub getTop As Int
'	Return mLbl.Top
'End Sub

Public Sub setTop(ll As Int)
	mLbl.Top = ll
End Sub